package com.maileon.api;

import java.util.List;

/**
 * The Class Page.
 *
 * @param <T> the generic type
 */
public class Page<T> {

    /**
     * The total items.
     */
    private int totalItems;

    /**
     * The page index.
     */
    private int pageIndex;

    /**
     * The page size.
     */
    private int pageSize;

    /**
     * The count pages.
     */
    private int countPages;

    /**
     * The items.
     */
    private List<T> items;

    /**
     * Instantiates a new page.
     */
    public Page() {

    }

    /**
     * Instantiates a new page.
     *
     * @param totalItems the total items
     * @param pageIndex the page index
     * @param pageSize the page size
     * @param countPages the count pages
     */
    public Page(int totalItems, int pageIndex, int pageSize, int countPages) {
        this.totalItems = totalItems;
        this.pageIndex = pageIndex;
        this.pageSize = pageSize;
        this.countPages = countPages;
    }

    /**
     * Gets the total items.
     *
     * @return the total items
     */
    public int getTotalItems() {
        return totalItems;
    }

    /**
     * Sets the total items.
     *
     * @param totalItems the new total items
     */
    public void setTotalItems(int totalItems) {
        this.totalItems = totalItems;
    }

    /**
     * Gets the page index.
     *
     * @return the page index
     */
    public int getPageIndex() {
        return pageIndex;
    }

    /**
     * Sets the page index.
     *
     * @param pageIndex the new page index
     */
    public void setPageIndex(int pageIndex) {
        this.pageIndex = pageIndex;
    }

    /**
     * Gets the page size.
     *
     * @return the page size
     */
    public int getPageSize() {
        return pageSize;
    }

    /**
     * Sets the page size.
     *
     * @param pageSize the new page size
     */
    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    /**
     * Gets the count pages.
     *
     * @return the count pages
     */
    public int getCountPages() {
        return countPages;
    }

    /**
     * Sets the count pages.
     *
     * @param countPages the new count pages
     */
    public void setCountPages(int countPages) {
        this.countPages = countPages;
    }

    /**
     * Gets the items.
     *
     * @return the items
     */
    public List<T> getItems() {
        return items;
    }

    /**
     * Sets the items.
     *
     * @param items the new items
     */
    public void setItems(List<T> items) {
        this.items = items;
    }

    @Override
    public String toString() {
        return "page{" + pageIndex + " of " + countPages + ". " + items.size() + " items}";
    }
}
