/**
 * xqueue.com
 */
package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result information for Image Check
 */
@XmlRootElement(name="ImageCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "images"})
public class ImageCheckResult implements Serializable {

    private long mailingId;

    private Date timestamp;

    private String state;

    private List<CheckedImage> images;

    @XmlElementWrapper(name="images")
    @XmlElement(name = "image", type=CheckedImage.class)
    public List<CheckedImage> getImages() {
        return images;
    }

    public void setImages(List<CheckedImage> images) {
        this.images = images;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    @Override
    public String toString() {
        String ret = "mailingId: " + mailingId + ", state: " + state + ", timestamp: " + timestamp;
        ret += "\nCheckedImages{";
        for (CheckedImage ci : images) {
            ret += ci.toString();
        }
        ret += "}";
        return ret;
    }
}
