package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

/**
 * Result information for Link Quality Check
 */
@XmlRootElement(name="LinkCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "links"})
public class LinkCheckResult implements Serializable {

    private long mailingId;

    private Date timestamp;

    private String state;

    private boolean success;

    private List<CheckedLink> links;

    @XmlElementWrapper(name="links")
    @XmlElement(name="item", type=CheckedLink.class)
    public List<CheckedLink> getLinks() {
        return links;
    }

    public void setLinks(List<CheckedLink> links) {
        this.links = links;
    }

    @XmlTransient
    public boolean isSuccess() {
        return success;
    }

    public void setSuccess(boolean success) {
        this.success = success;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    @Override
    public String toString() {
        String ret = "mailingId: " + mailingId + ", state: " + state + ", timestamp: " + timestamp;
        ret +="\nLinks{";
        for (CheckedLink link : links) {
            ret += link.toString();
        }
        ret +="}";
        return ret;
    }
}
