package com.maileon.api.reports;

import java.util.ArrayList;
import java.util.List;

import com.maileon.api.contacts.Contact;
import java.io.Serializable;

public class ReportContact extends Contact {

    public static class FieldBackup implements Serializable {

        private String type;

        private String subtype;

        private String name;

        private String option;

        private String value;

        public FieldBackup(String type, String subtype, String name, String option, String value) {
            this.type = type;
            this.subtype = subtype;
            this.name = name;
            this.option = option;
            this.value = value;
        }

        public String getType() {
            return type;
        }

        public void setType(String type) {
            this.type = type;
        }

        public String getSubtype() {
            return subtype;
        }

        public void setSubtype(String subtype) {
            this.subtype = subtype;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getOption() {
            return option;
        }

        public void setOption(String option) {
            this.option = option;
        }

        public String getValue() {
            return value;
        }

        public void setValue(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return String
                    .format("FieldBackup [type=%s, subtype=%s, name=%s, option=%s, value=%s]",
                            type, subtype, name, option, value);
        }

    }

    private final List<FieldBackup> fieldBackups = new ArrayList<>();

    public ReportContact(Contact c) {
        super.setAnonymous(c.isAnonymous());
        super.setEmail(c.getEmail());
        super.setExternalId(c.getExternalId());
        super.setCreated(c.getCreated());
        super.setUpdated(c.getUpdated());
        super.setId(c.getId());
        super.getStandardFields().putAll(c.getStandardFields());
        super.getCustomFields().putAll(c.getCustomFields());
    }

    public List<FieldBackup> getFieldBackups() {
        return fieldBackups;
    }

    @Override
    public String toString() {
        return String.format("contact[fieldBackups=%s,id=%s,email=%s,externalId=%s,anonymous=%s,created=%s,updated=%s]",
                fieldBackups, getId(), getEmail(), getExternalId(),
                isAnonymous(), (getCreated() == null) ? "" : getCreated().toString(), (getUpdated() == null) ? "" : getUpdated().toString());
    }

}
